unit MeryKeyBoardMap;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.StdCtrls, Vcl.ExtCtrls;

const
  FORM_WIDTH_SET    = 900;
  FORM_HEIGHT_SET   = 600;

type
  TFormMeryKeyBoardMap = class(TForm)
    Panel1: TPanel;
    ButtonSort0: TButton;
    ButtonSort1: TButton;
    ButtonCopyToClipTab: TButton;
    ButtonCopyToClipFixed: TButton;
    ButtonText: TButton;
    ButtonList: TButton;
    ButtonPasteFromClip: TButton;
    Memo1: TMemo;
    Panel2: TPanel;
    Memo2: TMemo;
    Panel3: TPanel;
    ListView1: TListView;
    Memo3: TMemo;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
    procedure SetKeySort0(Sender: TObject);
    procedure SetKeySort1(Sender: TObject);
    procedure GetKeySort0(Sender: TObject);
    procedure GetKeySort1(Sender: TObject);
    procedure ButtonSort0Click(Sender: TObject);
    procedure ButtonSort1Click(Sender: TObject);
    procedure ButtonCopyToClipTabClick(Sender: TObject);
    procedure ButtonListClick(Sender: TObject);
    procedure ButtonTextClick(Sender: TObject);
    procedure ButtonPasteFromClipClick(Sender: TObject);
    procedure ButtonCopyToClipFixedClick(Sender: TObject);

  private
    { Private 錾 }
    StrListKeyMap: TStringList;
    StrListKeyMapFixed: TStringList;
    StrListKeyMapKey0: TStringList;
    StrListKeyMapKey1: TStringList;
    StrListKeyMapKey2: TStringList;
    StrListKeyMapKey3: TStringList;
    StrListKeyMapKey4: TStringList;
    StrListKeyMapKey5: TStringList;
    StrListKeyMapKey6: TStringList;
    StrListKeyMapKey7: TStringList;
    StrListKeyMapKey8: TStringList;
    BoolMery: Boolean;
    BoolNewText: Boolean;
  public
    { Public 錾 }
  end;

var
  FormMeryKeyBoardMap: TFormMeryKeyBoardMap;

implementation

{$R *.dfm}

//L[ݒŃ\[g
function CompareTab(List: TStringList; Index1, Index2: Integer): Integer;
var
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  iPos14: Integer;
  iPos15: Integer;
  iPos16: Integer;
  iPos17: Integer;
  iPos21: Integer;
  iPos22: Integer;
  iPos23: Integer;
  iPos24: Integer;
  iPos25: Integer;
  iPos26: Integer;
  iPos27: Integer;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  sStr18: String;
  sStr19: String;
  sStr21: String;
  sStr22: String;
  sStr23: String;
  sStr24: String;
  sStr25: String;
  sStr26: String;
  sStr27: String;
  sStr28: String;
  sStr29: String;
begin
  //ŏ
  sStr11 := List[Index1];
  iPos11 := Pos(#09, sStr11);
  //PԖڂTABȍ~
  sStr12 := Copy(sStr11, iPos11+1, Length(sStr11));
  iPos12 := Pos(#09, sStr12);
  //QԖڂTABȍ~
  sStr13 := Copy(sStr12, iPos12+1, Length(sStr12));
  iPos13 := Pos(#09, sStr13);
  //QԖڂƂRԖڂ̊
  sStr14 := Copy(sStr13, 1, iPos13-1);

  //
  iPos14 := Pos('Shift+', sStr14);
  iPos15 := Pos('Ctrl+'  ,sStr14);
  iPos16 := Pos('Alt+'  , sStr14);
  //ݒ
  iPos17 := 1000;
  if iPos14 > 0 then
  begin
    iPos17 := iPos17 + 100;
  end;
  if iPos15 > 0 then
  begin
    iPos17 := iPos17 + 10;
  end;
  if iPos16 > 0 then
  begin
    iPos17 := iPos17 + 1;
  end;
  //u
  sStr15 := StringReplace(sStr14, 'Shift+', '', [rfReplaceAll]);
  sStr16 := StringReplace(sStr15, 'Ctrl+',  '', [rfReplaceAll]);
  sStr17 := StringReplace(sStr16, 'Alt+',   '', [rfReplaceAll]);
  sStr18 := StringReplace(sStr17, ' ',      '', [rfReplaceAll]);
  //ݒ
  sStr19 := Format('%.04d', [iPos17]) + sStr18;


  //ŏ
  sStr21 := List[Index2];
  iPos21 := Pos(#09, sStr21);
  //PԖڂTABȍ~
  sStr22 := Copy(sStr21, iPos21+1, Length(sStr21));
  iPos22 := Pos(#09, sStr22);
  //QԖڂTABȍ~
  sStr23 := Copy(sStr22, iPos22+1, Length(sStr22));
  iPos23 := Pos(#09, sStr23);
  //QԖڂƂRԖڂ̊
  sStr24 := Copy(sStr23, 1, iPos23-1);

  //
  iPos24 := Pos('Shift+', sStr24);
  iPos25 := Pos('Ctrl+' , sStr24);
  iPos26 := Pos('Alt+'  , sStr24);
  //ݒ
  iPos27 := 1000;
  if iPos24 > 0 then
  begin
    iPos27 := iPos27 + 100;
  end;
  if iPos25 > 0 then
  begin
    iPos27 := iPos27 + 10;
  end;
  if iPos26 > 0 then
  begin
    iPos27 := iPos27 + 1;
  end;
  //u
  sStr25 := StringReplace(sStr24, 'Shift+', '', [rfReplaceAll]);
  sStr26 := StringReplace(sStr25, 'Ctrl+',  '', [rfReplaceAll]);
  sStr27 := StringReplace(sStr26, 'Alt+',   '', [rfReplaceAll]);
  sStr28 := StringReplace(sStr27, ' ',      '', [rfReplaceAll]);
  //ݒ
  sStr29 := Format('%.04d', [iPos27]) + sStr28;

  //
  Result := CompareText(sStr19, sStr29);
end;

procedure TFormMeryKeyBoardMap.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormMeryKeyBoardMap.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //
end;

procedure TFormMeryKeyBoardMap.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //
end;

procedure TFormMeryKeyBoardMap.FormCreate(Sender: TObject);
begin
  //\
  Panel2.Align := alClient;
  Panel3.Align := alClient;

  //\
  Panel2.Visible := TRUE;
  Panel3.Visible := FALSE;
  ButtonText.Enabled            := TRUE;
  ButtonList.Enabled            := TRUE;
  ButtonPasteFromClip.Enabled   := TRUE;
  ButtonSort0.Enabled           := FALSE;
  ButtonSort1.Enabled           := FALSE;
  ButtonCopyToClipTab.Enabled   := FALSE;
  ButtonCopyToClipFixed.Enabled := FALSE;

  //m
  StrListKeyMap := TStringList.Create;
  StrListKeyMapFixed := TStringList.Create;
  StrListKeyMapKey0 := TStringList.Create;
  StrListKeyMapKey1 := TStringList.Create;
  StrListKeyMapKey2 := TStringList.Create;
  StrListKeyMapKey3 := TStringList.Create;
  StrListKeyMapKey4 := TStringList.Create;
  StrListKeyMapKey5 := TStringList.Create;
  StrListKeyMapKey6 := TStringList.Create;
  StrListKeyMapKey7 := TStringList.Create;
  StrListKeyMapKey8 := TStringList.Create;

  //NA
  Memo1.Lines.Clear;
  Memo2.Lines.Clear;
end;

procedure TFormMeryKeyBoardMap.FormDestroy(Sender: TObject);
begin
  //j
  StrListKeyMap.Free;
  StrListKeyMapFixed.Free;
  StrListKeyMapKey0.Free;
  StrListKeyMapKey1.Free;
  StrListKeyMapKey2.Free;
  StrListKeyMapKey3.Free;
  StrListKeyMapKey4.Free;
  StrListKeyMapKey5.Free;
  StrListKeyMapKey6.Free;
  StrListKeyMapKey7.Free;
  StrListKeyMapKey8.Free;
end;

procedure TFormMeryKeyBoardMap.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if (Shift = []) and (key = VK_ESCAPE) then
  begin
    //I
    Close;
  end;
end;

procedure TFormMeryKeyBoardMap.FormShow(Sender: TObject);
var
  iWidth1: Integer;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormMeryKeyBoardMap.KeyPreview := TRUE;

  //ݒ
  iWidth1 := (FormMeryKeyBoardMap.ClientWidth - 110 - 280 - 10) div 2;
  ListView1.Columns.Add.Caption  := 'JeS';
  ListView1.Columns[0].Width := 110;
  ListView1.Columns.Add.Caption  := 'R}h';
  ListView1.Columns[1].Width := iWidth1;
  ListView1.Columns.Add.Caption  := '݂̃L[';
  ListView1.Columns[2].Width := 280;
  ListView1.Columns.Add.Caption  := '@\';
  ListView1.Columns[3].Width := iWidth1;
  ListView1.Columns.Add.Caption  := '';
  ListView1.Columns[4].Width :=  10;
  ListView1.ViewStyle := vsReport;
  ListView1.RowSelect := TRUE;
  ListView1.MultiSelect := FALSE;
  ListView1.Align := alClient;
  ListView1.ReadOnly := TRUE;

end;

procedure TFormMeryKeyBoardMap.FormResize(Sender: TObject);
var
  iWidth1: Integer;
begin
  iWidth1 := (FormMeryKeyBoardMap.ClientWidth - 110 - 280 - 10) div 2;
  ListView1.Columns[0].Width := 110;
  ListView1.Columns[1].Width := iWidth1;
  ListView1.Columns[2].Width := 280;
  ListView1.Columns[3].Width := iWidth1;
  ListView1.Columns[4].Width :=  10;
end;

procedure TFormMeryKeyBoardMap.SetKeySort0(Sender: TObject);
var
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  nItem: TListItem;
begin
  //\
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  //ݒ
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow1].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow1].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow1].SubItems.Add(sStr17);
  end;
  //XV
  ListView1.Items.EndUpdate;

  //ݒ
  if ListView1.Items.Count > 0 then
  begin
    ListView1.ItemIndex := 0;
    ListView1.Selected := ListView1.Items[0];
    ListView1.ItemFocused := ListView1.Items[0];
  end;

end;

procedure TFormMeryKeyBoardMap.SetKeySort1(Sender: TObject);
var
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iRow2: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  nItem: TListItem;
begin
  //\
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  //
  iRow2 := 0;
  StrListKeyMap.Clear;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey1.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey1.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    //ǉ
    StrListKeyMap.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey2.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey2.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    //ǉ
    StrListKeyMap.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey3.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey3.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    //ǉ
    StrListKeyMap.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey4.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey4.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    //ǉ
    StrListKeyMap.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey5.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey5.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    //ǉ
    StrListKeyMap.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey6.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey6.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    //ǉ
    StrListKeyMap.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey7.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey7.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    //ǉ
    StrListKeyMap.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey8.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey8.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    //ǉ
    StrListKeyMap.Add(sStr11);
  end;
  //ݒ
  for iRow1 := 0 to StrListKeyMapKey0.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMapKey0.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    nItem := ListView1.Items.Add;
    nItem.Caption := sStr12;
    ListView1.Items.Item[iRow2].SubItems.Add(sStr14);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
    ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
    iRow2 := iRow2+1;
    //ǉ
    StrListKeyMap.Add(sStr11);
  end;
  //XV
  ListView1.Items.EndUpdate;

  //ݒ
  if ListView1.Items.Count > 0 then
  begin
    ListView1.ItemIndex := 0;
    ListView1.Selected := ListView1.Items[0];
    ListView1.ItemFocused := ListView1.Items[0];
  end;

end;

procedure TFormMeryKeyBoardMap.GetKeySort0(Sender: TObject);
var
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  iRow1: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
begin
  //ݒ
  BoolMery := TRUE;
  for iRow1 := 0 to Memo2.Lines.Count-1 do
  begin
    //擾
    sStr11 := Memo2.Lines.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    if iPos11 = 0 then
    begin
      BoolMery := FALSE;
      Break;
    end;
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    if iPos12 = 0 then
    begin
      BoolMery := FALSE;
      Break;
    end;
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    if iPos13 = 0 then
    begin
      BoolMery := FALSE;
      Break;
    end;
  end;

  //\
  if BoolMery = FALSE then
  begin
    ListView1.Items.BeginUpdate;
    ListView1.Items.Clear;
    ListView1.Items.EndUpdate;
    showmessage('Mery ̃L[{[h}bvł͂܂');
    Exit;
  end
  else
  begin
    StrListKeyMap.Assign(Memo2.Lines);
  end;



end;

procedure TFormMeryKeyBoardMap.GetKeySort1(Sender: TObject);
var
  iRow1: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  iPos14: Integer;
  iPos15: Integer;
  iPos16: Integer;
  iPos21: Integer;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr21: String;
  sStr22: String;
  sStr23: String;
  sStr24: String;
  sStr25: String;
begin
  //ݒ
  BoolMery := TRUE;
  for iRow1 := 0 to Memo2.Lines.Count-1 do
  begin
    //擾
    sStr11 := Memo2.Lines.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    if iPos11 = 0 then
    begin
      BoolMery := FALSE;
      Break;
    end;
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    if iPos12 = 0 then
    begin
      BoolMery := FALSE;
      Break;
    end;
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    if iPos13 = 0 then
    begin
      BoolMery := FALSE;
      Break;
    end;
  end;

  //\
  if BoolMery = FALSE then
  begin
    ListView1.Items.BeginUpdate;
    ListView1.Items.Clear;
    ListView1.Items.EndUpdate;
    showmessage('Mery ̃L[{[h}bvł͂܂');
    Exit;
  end
  else
  begin
    StrListKeyMap.Assign(Memo2.Lines);
  end;

  //ݒ
  StrListKeyMapKey0.Clear;
  StrListKeyMapKey1.Clear;
  StrListKeyMapKey2.Clear;
  StrListKeyMapKey3.Clear;
  StrListKeyMapKey4.Clear;
  StrListKeyMapKey5.Clear;
  StrListKeyMapKey6.Clear;
  StrListKeyMapKey7.Clear;

  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //ŏ
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#09, sStr11);
    //PԖڂTABȍ~
    sStr12 := Copy(sStr11, iPos11+1, Length(sStr11));
    iPos12 := Pos(#09, sStr12);
    //QԖڂTABȍ~
    sStr13 := Copy(sStr12, iPos12+1, Length(sStr12));
    iPos13 := Pos(#09, sStr13);
    //QԖڂƂRԖڂ̊
    sStr14 := Copy(sStr13, 1, iPos13-1);

    //,, J}ɒu
    sStr21 := StringReplace(sStr14, ',,',     'J}',  [rfReplaceAll]);
    //,  #09 ɒu
    sStr22 := StringReplace(sStr21, ',',      #09,       [rfReplaceAll]);
    //J} #09,ɒu
    sStr23 := StringReplace(sStr22, 'J}', ',' + #09, [rfReplaceAll]);
    //󔒂폜
    sStr24 := StringReplace(sStr23, ' ',      '',        [rfReplaceAll]);

    //PԖ
    iPos21 := Pos(#09, sStr24);
    if iPos21 > 0 then
    begin
      sStr25 := Copy(sStr24, 1, iPos21-1);
    end
    else
    begin
      sstr25 := sStr24;
    end;

    //
    iPos14 := Pos('Shift+', sStr25);
    iPos15 := Pos('Ctrl+'  ,sStr25);
    iPos16 := Pos('Alt+'  , sStr25);

    //
    if sStr25 = '' then                                         //
    begin
      StrListKeyMapKey0.Add(sStr11);
    end
    else if (iPos14 = 0) and (iPos15 = 0) and (iPos16 = 0) then //
    begin
      StrListKeyMapKey1.Add(sStr11);
    end
    else if (iPos14 > 0) and (iPos15 = 0) and (iPos16 = 0) then  //shift
    begin
      StrListKeyMapKey2.Add(sStr11);
    end
    else if (iPos14 > 0) and (iPos15 > 0) and (iPos16 = 0) then  //shift Ctrl
    begin
      StrListKeyMapKey3.Add(sStr11);
    end
    else if (iPos14 > 0) and (iPos15 = 0) and (iPos16 > 0) then  //shift alt
    begin
      StrListKeyMapKey4.Add(sStr11);
    end
    else if (iPos14 > 0) and (iPos15 > 0) and (iPos16 > 0) then  //shift ctl alt
    begin
      StrListKeyMapKey5.Add(sStr11);
    end
    else if (iPos14 = 0) and (iPos15 > 0) and (iPos16 = 0) then  //ctrl
    begin
      StrListKeyMapKey6.Add(sStr11);
    end
    else if (iPos14 = 0) and (iPos15 > 0) and (iPos16 > 0) then  //ctrl alt
    begin
      StrListKeyMapKey7.Add(sStr11);
    end
    else if (iPos14 = 0) and (iPos15 = 0) and (iPos16 > 0) then //alt
    begin
      StrListKeyMapKey8.Add(sStr11);
    end
    else
    begin
      //
    end;
  end;

  //\[g
  StrListKeyMapKey1.CustomSort(CompareTab);
  StrListKeyMapKey2.CustomSort(CompareTab);
  StrListKeyMapKey3.CustomSort(CompareTab);
  StrListKeyMapKey4.CustomSort(CompareTab);
  StrListKeyMapKey5.CustomSort(CompareTab);
  StrListKeyMapKey6.CustomSort(CompareTab);
  StrListKeyMapKey7.CustomSort(CompareTab);
  StrListKeyMapKey8.CustomSort(CompareTab);

end;

procedure TFormMeryKeyBoardMap.ButtonSort0Click(Sender: TObject);
begin
  GetKeySort0(Sender);
  if BoolMery = TRUE then
  begin
    SetKeySort0(Sender);
  end;
end;

procedure TFormMeryKeyBoardMap.ButtonSort1Click(Sender: TObject);
begin
  GetKeySort1(Sender);
  if BoolMery = TRUE then
  begin
    SetKeySort1(Sender);
  end;
end;

procedure TFormMeryKeyBoardMap.ButtonTextClick(Sender: TObject);
begin
  //\
  Panel2.Visible := TRUE;
  Panel3.Visible := FALSE;
  ButtonText.Enabled            := TRUE;
  ButtonList.Enabled            := TRUE;
  ButtonPasteFromClip.Enabled   := TRUE;
  ButtonSort0.Enabled           := FALSE;
  ButtonSort1.Enabled           := FALSE;
  ButtonCopyToClipTab.Enabled   := FALSE;
  ButtonCopyToClipFixed.Enabled := FALSE;
end;

procedure TFormMeryKeyBoardMap.ButtonListClick(Sender: TObject);
begin
  //\
  Panel2.Visible := FALSE;
  Panel3.Visible := TRUE;
  ButtonText.Enabled            := TRUE;
  ButtonList.Enabled            := TRUE;
  ButtonPasteFromClip.Enabled   := FALSE;
  ButtonSort0.Enabled           := TRUE;
  ButtonSort1.Enabled           := TRUE;
  ButtonCopyToClipTab.Enabled   := TRUE;
  ButtonCopyToClipFixed.Enabled := TRUE;

  //
  if BoolNewText = TRUE then
  begin
    BoolNewText := FALSE;
    ButtonSort0Click(Sender);
  end
end;


procedure TFormMeryKeyBoardMap.ButtonPasteFromClipClick(Sender: TObject);
begin
  //ݒ
  BoolNewText := TRUE;
  Memo2.Lines.Clear;
  Memo2.ReadOnly := FALSE;
  Memo2.PasteFromClipboard;
  Memo2.ReadOnly := TRUE;
end;

procedure TFormMeryKeyBoardMap.ButtonCopyToClipTabClick(Sender: TObject);
begin
  //s
  Memo1.Lines.Assign(StrListKeyMap);
  Memo1.SelectAll;
  Memo1.CopyToClipboard;
  //\
  showmessage('NbvɃRs[܂');
end;

procedure TFormMeryKeyBoardMap.ButtonCopyToClipFixedClick(Sender: TObject);
var
  iRow1: Integer;
  iLen1: Integer;
  iLen2: Integer;
  iLen3: Integer;
  iLen4: Integer;
  iLen11: Integer;
  iLen12: Integer;
  iLen13: Integer;
  iLen14: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr21: String;
  sStr22: String;
  sStr23: String;
  sStr24: String;
  sStr31: String;
  sStr32: String;
  sStr33: String;
  sStr34: String;
begin
  iLen1 := 0;
  iLen2 := 0;
  iLen3 := 0;
  iLen4 := 0;
//  iLen11 := 0;
//  iLen12 := 0;
//  iLen13 := 0;
//  iLen14 := 0;
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //ŏ
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#09, sStr11);
    //PԖڂTABȍ~
    sStr12 := Copy(sStr11, iPos11+1, Length(sStr11));
    iPos12 := Pos(#09, sStr12);
    //QԖڂTABȍ~
    sStr13 := Copy(sStr12, iPos12+1, Length(sStr12));
    iPos13 := Pos(#09, sStr13);
    //RԖڂTABȍ~
    sStr14 := Copy(sStr13, iPos13+1, Length(sStr13));

    //擾
    sStr21 := Copy(sStr11, 1, iPos11-1);
    sStr22 := Copy(sStr12, 1, iPos12-1);
    sStr23 := Copy(sStr13, 1, iPos13-1);
    sStr24 := sStr14;

    //XV
    if Length(AnsiString(sStr21)) > iLen1 then
    begin
      iLen1 := Length(AnsiString(sStr21));
    end;
    if Length(AnsiString(sStr22)) > iLen2 then
    begin
      iLen2 := Length(AnsiString(sStr22));
    end;
    if Length(AnsiString(sStr23)) > iLen3 then
    begin
      iLen3 := Length(AnsiString(sStr23));
    end;
    if Length(AnsiString(sStr24)) > iLen4 then
    begin
      iLen4 := Length(AnsiString(sStr24));
    end;
  end;

  //ݒ
  StrListKeyMapFixed.Clear;
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //ŏ
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#09, sStr11);
    //PԖڂTABȍ~
    sStr12 := Copy(sStr11, iPos11+1, Length(sStr11));
    iPos12 := Pos(#09, sStr12);
    //QԖڂTABȍ~
    sStr13 := Copy(sStr12, iPos12+1, Length(sStr12));
    iPos13 := Pos(#09, sStr13);
    //RԖڂTABȍ~
    sStr14 := Copy(sStr13, iPos13+1, Length(sStr13));

    //擾
    sStr21 := Copy(sStr11, 1, iPos11-1);
    sStr22 := Copy(sStr12, 1, iPos12-1);
    sStr23 := Copy(sStr13, 1, iPos13-1);
    sStr24 := sStr14;
    iLen11 := Length(AnsiString(sStr21));
    iLen12 := Length(AnsiString(sStr22));
    iLen13 := Length(AnsiString(sStr23));
    iLen14 := Length(AnsiString(sStr24));

    //ݒ
    sStr31 := sStr21 + StringOfChar(' ', iLen1 - iLen11 + 2);
    sStr32 := sStr22 + StringOfChar(' ', iLen2 - iLen12 + 2);
    sStr33 := sStr23 + StringOfChar(' ', iLen3 - iLen13 + 2);
    sStr34 := sStr24 + StringOfChar(' ', iLen4 - iLen14 + 2);
    //ǉ
    StrListKeyMapFixed.Add(sStr31 + sStr32 + sStr33 + sstr34);
  end;

  //s
  Memo1.Lines.Assign(StrListKeyMapFixed);
  Memo1.SelectAll;
  Memo1.CopyToClipboard;
  //\
  showmessage('NbvɃRs[܂');
end;

end.

